/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2004 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer: Florent BENOIT
 * --------------------------------------------------------------------------
 * $Id: Services.java,v 1.1 2004/06/11 09:27:47 benoitf Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.ant.jonasbase;

import org.objectweb.jonas.ant.JOnASBaseTask;

/**
 * Allow to configure the list of services in jonas.properties file
 * @author Florent Benoit
 */
public class Services extends Tasks {

    /**
     * Info for the logger
     */
    private static final String INFO = "[JOnAS] ";

    /**
     * Default list of services
     */
    private static final String DEFAULT_SERVICES = "registry,jmx,jtm,db,dbm,security,jms,resource,ejb,web,ear";

    /**
     * Default constructor
     */
    public Services() {
        super();
    }

    /**
     * Set the names of the services
     * @param serviceNames list of services
     */
    public void setNames(String serviceNames) {
        JReplace propertyReplace = new JReplace();
        propertyReplace.setConfigurationFile(JOnASBaseTask.JONAS_CONF_FILE);
        propertyReplace.setToken(DEFAULT_SERVICES);
        propertyReplace.setValue(serviceNames);
        propertyReplace.setLogInfo(INFO + "Setting JOnAS services to :" + serviceNames);
        addTask(propertyReplace);
    }

}