/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ManagementReprFactory.java,v 1.6 2004/05/06 14:37:28 danesa Exp $
 * --------------------------------------------------------------------------
 */
package org.objectweb.jonas.jmx;

//import java.util.Properties;
//import java.io.InputStream;

// JOnAS Log
import org.objectweb.jonas.common.Log;
import org.objectweb.util.monolog.api.BasicLevel;
import org.objectweb.util.monolog.api.Logger;

/**
 * Provides an appropriate management representative.
 * @author Adriana Danes
 */
public class ManagementReprFactory {
    /**
     * Private constructor
     */
    private ManagementReprFactory() {
    }

    private static Logger logger = null;

    public static ManagementRepr getManagementRepr() {
        logger = Log.getLogger("org.objectweb.jonas.jmx");

        ManagementRepr representative = null;
        ClassLoader classLoader = ManagementReprFactory.class.getClassLoader();
        try {
            Class managemntRepClass = classLoader.loadClass("org.objectweb.jonas.jmx.ManagementReprImpl");
            logger.log(BasicLevel.DEBUG, "ManagementReprFactory , managemntRep class loaded");
            representative = (ManagementRepr) managemntRepClass.newInstance();
            logger.log(BasicLevel.DEBUG, "ManagementReprFactory , managemntRep created");
        } catch (Exception e) {
            logger.log(BasicLevel.DEBUG, "ManagementReprFactory exception : " + e.toString());
        }
        return representative;
    }
}
