/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999-2004 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation; either version 2.1 of the License, or any later
 * version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
 *
 * Initial developer(s): Takoua Abdellatif.
 * Contributor(s): _______________________.
 */
package org.objectweb.jonas.server.discovery;

import javax.management.Notification;
import javax.management.NotificationListener;
import javax.management.remote.JMXServiceURL;

/**
 *
 * @author <a href="mailto:Takoua.Abdellatif@inria.fr">Takoua Abdellatif</a>
 * @version 1.0
 */
public class MonitorTest implements NotificationListener {

    /**
     * This class is a test of a discovery monitor. It is a listener for the discovery client and enroller.
     */
    public MonitorTest() {
        super();
    }

    /* (non-Javadoc)
     * @see javax.management.NotificationListener#handleNotification(javax.management.Notification, java.lang.Object)
     */
    public void handleNotification(Notification notification, Object handback) {
        System.out.println("*****************************************************");
        System.out.println("Monitor: jonas address is "+ ((DiscEvent)notification.getUserData()).getSourceAddress());
        System.out.println("Monitor: jonas state is "+ notification.getType());
        System.out.println("Monitor: jonas domain is "+ ((DiscEvent)notification.getUserData()).getDomainName());
        if (notification.getType().equals("running")) {
            JMXServiceURL[] urls = ((DiscEvent)notification.getUserData()).getConnectorURL();
            for (int i = 0; i < urls.length; i++) {
                System.out.println("Monitor: jonas connector url is " + urls[i]);
                System.out.println("Monitor: jonas connector protocol is " + urls[i].getProtocol());
            }
        }
        System.out.println("*****************************************************");
    }

}
