/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EditJmxServerAction.java,v 1.7 2004/08/23 14:43:14 danesa Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.jonasserver;

import java.io.IOException;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.JonasObjectName;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;

/**
 * @author  Michel-Ange ANTON
 */

public class EditJmxServerAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {
        // Force the node selected in tree
        m_WhereAreYou.selectNameNode(getTreeBranchName(DEPTH_SERVER), true);
        // Form used
        JmxServerForm oForm = (JmxServerForm) p_Form;
        try {
            // Object name used
            ObjectName oObjectName = JonasObjectName.jmxService();
            // Copy scalar properties
            oForm.setMBeanServerId(getStringAttribute(oObjectName, "MBeanServerId"));
            oForm.setSpecificationName(getStringAttribute(oObjectName, "SpecificationName"));
            oForm.setSpecificationVersion(getStringAttribute(oObjectName, "SpecificationVersion"));
            oForm.setSpecificationVendor(getStringAttribute(oObjectName, "SpecificationVendor"));
            oForm.setImplementationName(getStringAttribute(oObjectName, "ImplementationName"));
            oForm.setImplementationVersion(getStringAttribute(oObjectName, "ImplementationVersion"));
            oForm.setImplementationVendor(getStringAttribute(oObjectName, "ImplementationVendor"));
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }

        // Forward to the jsp.
        return (p_Mapping.findForward("JmxServer"));
    }

}
