/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EditJvmAction.java,v 1.2 2004/03/19 14:31:49 sauthieg Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.jonasserver;

import java.io.IOException;

import javax.management.MalformedObjectNameException;
import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;
/**
 * @author Adriana DANES
 */

public class EditJvmAction extends JonasBaseAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {
        // Force the node selected in tree
        m_WhereAreYou.selectNameNode(getTreeBranchName(DEPTH_SERVER), true);

        ActionErrors oErrors = new ActionErrors();

        // The MBean of current Jonas server
        ObjectName on_server = m_WhereAreYou.getCurrentJonasServer();
        // JVM MBean
        ObjectName oObjectName = null;
        // List of JVMs - in reality we have only one
        String[] jvms = (String []) JonasManagementRepr.getAttribute(on_server, "javaVMs");
        try {
            if (jvms.length>0) {
                oObjectName = new ObjectName(jvms[0]);
            } else {
                oErrors.add("JVMs", new ActionError("error.server.jonas.jvms"));
                saveErrors(p_Request, oErrors);
                return (p_Mapping.findForward("Global Error")); 
            }
        } catch (MalformedObjectNameException e) {
            addGlobalError(e);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        
        // Form used
        JvmForm oForm = (JvmForm) p_Form;
        try {
            // Copy scalar properties
            oForm.setJavaVendor(getStringAttribute(oObjectName, "javaVendor"));
            oForm.setJavaVersion(getStringAttribute(oObjectName, "javaVersion"));
            oForm.setNode(getStringAttribute(oObjectName, "node"));
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }

        // Forward to the jsp.
        return (p_Mapping.findForward("Jvm"));
    }

}
