/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2003-2004 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: ListRegistryAction.java,v 1.9 2004/11/25 14:31:00 danesa Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.jonasserver;

import java.io.IOException;
import java.util.Iterator;
import java.util.List;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.jmx.J2eeObjectName;
import org.objectweb.jonas.jmx.JonasManagementRepr;
import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;

/**
 * @author Adriana Danes <br>
 * Contributor Michel-Ange Anton
 */
public class ListRegistryAction extends JonasBaseAction {

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {

        // Force the node selected in tree
        m_WhereAreYou.selectNameNode(getTreeBranchName(DEPTH_SERVER), true);
        // Form used
        JndiResourcesForm oForm = new JndiResourcesForm();
        
        try {
            String pDomainName = m_WhereAreYou.getCurrentDomainName();
            String pServerName = m_WhereAreYou.getCurrentJonasServerName();
            ObjectName ons = J2eeObjectName.JNDIResources(pDomainName, pServerName);
            Iterator itNames = JonasManagementRepr.queryNames(ons).iterator();
            List lNames = null;
            int nbJNDIResources = 0;
            while (itNames.hasNext()) {
            	JndiResourceItem item = new JndiResourceItem();
                ObjectName itOn = (ObjectName) itNames.next();
                item.setProviderUrl(getStringAttribute(itOn, "providerUrl"));
                item.setProtocol(getStringAttribute(itOn, "protocol"));
                item.setResourceON(itOn.toString());
                lNames = getListAttribute(itOn, "names");
                oForm.addProvider(item);
                nbJNDIResources++;
            }
            if (nbJNDIResources == 1) {
            	oForm.setListNames(lNames);
            }
            p_Request.setAttribute("jndiResourcesForm", oForm);
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        // Forward to the jsp.
        return (p_Mapping.findForward("Registry"));
    }
}
