/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

package org.objectweb.jonas.webapp.jonasadmin.joramplatform;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import org.objectweb.jonas.webapp.jonasadmin.JonasBaseAction;

/**
 * @author Adriana Danes
 */
public abstract class EditJoramBaseAction extends JonasBaseAction {
    /**
     * Treat specific case where Joram RAR was unloaded
     * @param t Exception to treat
     * @param pMapping provided by executeAction
     * @param pRequest provided by executeAction
     * @return
     */
    protected ActionForward treatError(Throwable t, ActionMapping pMapping, HttpServletRequest pRequest) {
        String causeClassName = t.getCause().getClass().getName();
        if (causeClassName.equals("javax.management.InstanceNotFoundException")) {
            t = new Throwable("No MBeans found for the Joram platform. Try to refresh!", t);
        }
        addGlobalError(t);
        saveErrors(pRequest, m_Errors);
        return (pMapping.findForward("Global Error"));
    }
    
}
