/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: CatalinaAccessLogValveForm.java,v 1.2 2004/03/19 14:31:48 sauthieg Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.logging;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.webapp.jonasadmin.Jlists;

/**
 * @author Michel-Ange ANTON
 */

public final class CatalinaAccessLogValveForm extends CatalinaValveForm {

// ----------------------------------------------------- Properties Variables

    private String directory = null;
    private String pattern = null;
    private String prefix = null;
    private String suffix = null;
    private boolean rotatable = true;
    private boolean resolveHosts = false;

    private List booleanValues = Jlists.getBooleanValues();

// --------------------------------------------------------- Public Methods

    public void reset(ActionMapping mapping, HttpServletRequest request) {

        super.reset(mapping, request);
        directory = "logs";
        prefix = "access_log.";
        suffix = ".txt";
        pattern = "%h %l %u %t \"%r\" %s %b";
        resolveHosts = false;
        rotatable = true;
    }

    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        ActionErrors oErrors = new ActionErrors();
        // prefix
        if ((prefix == null) || (prefix.length() < 1)) {
            oErrors.add("pattern", new ActionError("error.logger.catalina.access.prefix.required"));
        }
        // default is a 0 length string
        if ((suffix == null) || (suffix.length() < 1)) {
            suffix = "";
        }
        // pattern
        if ((pattern == null) || (pattern.length() < 1)) {
            oErrors.add("pattern", new ActionError("error.logger.catalina.access.pattern.required"));
        }
        return oErrors;
    }

// ------------------------------------------------------------- Properties Methods

    public List getBooleanValues() {
        return booleanValues;
    }

    public void setBooleanValues(List booleanValues) {
        this.booleanValues = booleanValues;
    }

    public String getDirectory() {
        return this.directory;
    }

    public void setDirectory(String directory) {
        this.directory = directory;
    }

    public String getPattern() {
        return this.pattern;
    }

    public void setPattern(String pattern) {
        this.pattern = pattern;
    }

    public String getPrefix() {
        return this.prefix;
    }

    public void setPrefix(String prefix) {
        this.prefix = prefix;
    }

    public String getSuffix() {
        return this.suffix;
    }

    public void setSuffix(String suffix) {
        this.suffix = suffix;
    }

    public boolean isResolveHosts() {
        return this.resolveHosts;
    }

    public void setResolveHosts(boolean resolveHosts) {
        this.resolveHosts = resolveHosts;
    }

    public boolean isRotatable() {
        return this.rotatable;
    }

    public void setRotatable(boolean rotatable) {
        this.rotatable = rotatable;
    }
}
