/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: EditCatalinaAccessLoggerAction.java,v 1.5 2004/03/19 14:31:48 sauthieg Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.logging;

import java.io.IOException;

import javax.management.ObjectName;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.objectweb.jonas.webapp.jonasadmin.WhereAreYou;

/**
 * @author Michel-Ange ANTON
 */

public class EditCatalinaAccessLoggerAction extends BaseLoggerAction {

// --------------------------------------------------------- Public Methods

    public ActionForward executeAction(ActionMapping p_Mapping, ActionForm p_Form
        , HttpServletRequest p_Request, HttpServletResponse p_Response)
        throws IOException, ServletException {

        // Parameters
        String sAction = p_Request.getParameter("action");
        if (sAction == null) {
            sAction = "edit";
        }
        String sObjectName = p_Request.getParameter("select");
        // Form used
        CatalinaAccessLogValveForm oForm = null;
        if (("create".equals(sAction) == true) || (sObjectName != null)) {
            oForm = new CatalinaAccessLogValveForm();
            m_Session.setAttribute("catalinaAccessLoggerForm", oForm);
            oForm.reset(p_Mapping, p_Request);
            oForm.setObjectName(sObjectName);
        }
        else {
            oForm = (CatalinaAccessLogValveForm) m_Session.getAttribute("catalinaAccessLoggerForm");
        }
        oForm.setAction(sAction);
        // Polulate
        try {
            if (oForm.getObjectName() != null) {
                // Get the access logger
                ObjectName on = new ObjectName(oForm.getObjectName());
                // Populate
                oForm.setObjectName(on.toString());
                oForm.setDirectory(getStringAttribute(on, "directory"));
                oForm.setPattern(getStringAttribute(on, "pattern"));
                oForm.setPrefix(getStringAttribute(on, "prefix"));
                oForm.setResolveHosts(getBooleanAttribute(on, "resolveHosts"));
                oForm.setRotatable(getBooleanAttribute(on, "rotatable"));
                oForm.setSuffix(getStringAttribute(on, "suffix"));
                // Force the node selected in tree
                m_WhereAreYou.selectNameNode(getTreeBranchName(DEPTH_SERVER)
                    + WhereAreYou.NODE_SEPARATOR + "logging" + WhereAreYou.NODE_SEPARATOR
                    + LoggerItem.LOGGER_CATALINA_ACCESS, true);
            }
        }
        catch (Throwable t) {
            addGlobalError(t);
            saveErrors(p_Request, m_Errors);
            return (p_Mapping.findForward("Global Error"));
        }
        // Forward to the jsp.
        return (p_Mapping.findForward("Catalina Access Logger"));
    }

}
