/*
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: LoggerItem.java,v 1.2 2003/11/12 17:19:35 antonma Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas.webapp.jonasadmin.logging;

import org.objectweb.jonas.webapp.jonasadmin.common.NameItem;

/**
 * @author Michel-Ange ANTON
 */
public class LoggerItem implements NameItem {

// --------------------------------------------------------- Constants

    public static String LOGGER_JONAS = "logger.jonas";
    public static String LOGGER_CATALINA_ACCESS = "logger.catalina.access";

// --------------------------------------------------------- Properties Variables

    private String name = null;
    private String forward = null;
    private String type = null;
    private String objectName = null;

// --------------------------------------------------------- Constructors

    public LoggerItem() {
    }

    public LoggerItem(String p_Name, String p_Type, String p_Forward) {
        setName(p_Name);
        setType(p_Type);
        setForward(p_Forward);
    }

    public LoggerItem(String p_Name, String p_Type, String p_Forward, String p_ObjectName) {
        this(p_Name, p_Type, p_Forward);
        setObjectName(p_ObjectName);
    }

// --------------------------------------------------------- Properties Methods

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getForward() {
        return forward;
    }

    public void setForward(String forward) {
        this.forward = forward;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getObjectName() {
        return objectName;
    }

    public void setObjectName(String objectName) {
        this.objectName = objectName;
    }
}