/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 1999 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or 1any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * Initial developer: Florent BENOIT
 * --------------------------------------------------------------------------
 * $Id: JonasWebAppDTDs.java,v 1.1 2004/05/25 14:26:35 sauthieg Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonas_web.deployment.lib;

import org.objectweb.jonas_lib.deployment.api.CommonsDTDs;

/**
 * This class defines the declarations of DTDs for jonas-web.xml
 * @author Florent Benoit
 */
public class JonasWebAppDTDs extends CommonsDTDs {

    /**
     * List of jonas-web-app dtds
     */
    private static final String[] JONAS_WEBAPP_DTDS = new String[] {
        "jonas-web-app_2_6.dtd",
        "jonas-web-app_3_1.dtd",
        "jonas-web-app_3_3.dtd"
    };

    /**
     * List of jonas-web-app publicId
     */
    private static final String[] JONAS_WEBAPP_DTDS_PUBLIC_ID = new String[] {
        "-//ObjectWeb//DTD JOnAS Web App 2.6//EN",
        "-//ObjectWeb//DTD JOnAS Web App 3.1//EN",
        "-//ObjectWeb//DTD JOnAS Web App 3.3//EN"
    };


    /**
     * Build a new object for jonas-web.xml DTDs handling
     */
    public JonasWebAppDTDs() {
        super();
        addMapping(JONAS_WEBAPP_DTDS, JONAS_WEBAPP_DTDS_PUBLIC_ID);
    }


}
