/**
 * JOnAS : Java(TM) OpenSource Application Server
 * Copyright (C) 2004 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: JOnASClientGeneratorFactory.java,v 1.1 2004/11/19 09:23:00 sauthieg Exp $
 * --------------------------------------------------------------------------
 */
package org.objectweb.jonas_ws.wsgen.generator.ews.wsdltoj2ee;

import javax.wsdl.Definition;
import javax.wsdl.Service;

import org.apache.axis.wsdl.gen.Generator;
import org.apache.axis.wsdl.symbolTable.ServiceEntry;
import org.apache.axis.wsdl.symbolTable.SymbolTable;
import org.apache.axis.wsdl.toJava.JavaDefinitionWriter;
import org.apache.geronimo.ews.jaxrpcmapping.J2eeGeneratorFactory;

import org.objectweb.jonas_ws.wsgen.generator.axis.wsdl2java.JOnASServiceWriter;


/**
 * JOnAS implementation of J2EEGeneratorFactory for the client side.
 * @author Guillaume Sauthier
 */
public class JOnASClientGeneratorFactory extends J2eeGeneratorFactory {

    /**
     * @see org.apache.geronimo.ews.jaxrpcmapping.J2eeGeneratorFactory#addDefinitionGenerators()
     */
    protected void addDefinitionGenerators() {
        // for faults
        addGenerator(Definition.class, JavaDefinitionWriter.class);
        // for deploy.wsdd
        addGenerator(Definition.class, J2EEClientDeployWriter.class);
    }

    /**
     * Use the JOnASServiceWriter instead of default JavaServiceWriter
     * @param service wsdl:service
     * @param symbolTable symbol Table
     * @return Returns the JOnASServiceWriter
     */
    public Generator getGenerator(Service service, SymbolTable symbolTable) {
        Generator writer = new JOnASServiceWriter(emitter, service, symbolTable);
        ServiceEntry sEntry = symbolTable.getServiceEntry(service.getQName());
        serviceWriters.addStuff(writer, sEntry, symbolTable);
        return serviceWriters;
    }
}
