/**
 * JOnAS : Java(TM) OpenSource Application Server
 * Copyright (C) 2004 Bull S.A.
 * Contact: jonas-team@objectweb.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: JOnASJ2EEWebServicesContext.java,v 1.1 2004/11/19 09:23:00 sauthieg Exp $
 * --------------------------------------------------------------------------
 */
package org.objectweb.jonas_ws.wsgen.generator.ews.wsdltoj2ee;

import java.util.List;
import java.util.Vector;

import org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext;
import org.apache.geronimo.ews.ws4j2ee.context.JaxRpcMapperContext;
import org.apache.geronimo.ews.ws4j2ee.context.MiscInfo;
import org.apache.geronimo.ews.ws4j2ee.context.j2eeDD.EJBContext;
import org.apache.geronimo.ews.ws4j2ee.context.j2eeDD.WebContext;
import org.apache.geronimo.ews.ws4j2ee.context.webservices.client.interfaces.ServiceReferanceContext;
import org.apache.geronimo.ews.ws4j2ee.context.webservices.server.interfaces.WSCFContext;
import org.apache.geronimo.ews.ws4j2ee.context.wsdl.WSDLContext;
import org.apache.geronimo.ews.ws4j2ee.toWs.Ws4J2eeFactory;

import org.objectweb.jonas_ws.deployment.api.ServiceDesc;


/**
 * JOnAS implementation of the J2EEWebServiceContext from EWS
 * @author Guillaume Sauthier
 */
public class JOnASJ2EEWebServicesContext implements J2EEWebServiceContext {

    /**
     * list of service-ref (for client)
     */
    private List srCtx;

    /**
     * service description (for endpoint)
     */
    private ServiceDesc serviceDesc = null;

    /**
     * Default constructor
     */
    public JOnASJ2EEWebServicesContext() {
        super();
        this.srCtx = new Vector();
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getWSDLContext()
     */
    public WSDLContext getWSDLContext() {
        return null;
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#setWSDLContext(org.apache.geronimo.ews.ws4j2ee.context.wsdl.WSDLContext)
     */
    public void setWSDLContext(WSDLContext wsdlcontext) {
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getWSCFContext()
     */
    public WSCFContext getWSCFContext() {
        return null;
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#setWSCFContext(org.apache.geronimo.ews.ws4j2ee.context.webservices.server.interfaces.WSCFContext)
     */
    public void setWSCFContext(WSCFContext wscfcontext) {
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getJAXRPCMappingContext()
     */
    public JaxRpcMapperContext getJAXRPCMappingContext() {
        return null;
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#setJAXRPCMappingContext(org.apache.geronimo.ews.ws4j2ee.context.JaxRpcMapperContext)
     */
    public void setJAXRPCMappingContext(JaxRpcMapperContext context) {
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getMiscInfo()
     */
    public MiscInfo getMiscInfo() {
        return null;
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#setMiscInfo(org.apache.geronimo.ews.ws4j2ee.context.MiscInfo)
     */
    public void setMiscInfo(MiscInfo info) {

    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#validate()
     */
    public void validate() {
    }

    /**
     * @return Returns the serviceDesc.
     */
    public ServiceDesc getServiceDesc() {
        return serviceDesc;
    }

    /**
     * @param serviceDesc The serviceDesc to set.
     */
    public void setServiceDesc(ServiceDesc serviceDesc) {
        this.serviceDesc = serviceDesc;
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#setFactory(org.apache.geronimo.ews.ws4j2ee.toWs.Ws4J2eeFactory)
     */
    public void setFactory(Ws4J2eeFactory factory) {
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getFactory()
     */
    public Ws4J2eeFactory getFactory() {
        return null;
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getEJBDDContext()
     */
    public EJBContext getEJBDDContext() {
        return null;
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#setEJBDDContext(org.apache.geronimo.ews.ws4j2ee.context.j2eeDD.EJBContext)
     */
    public void setEJBDDContext(EJBContext context) {
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getWebDDContext()
     */
    public WebContext getWebDDContext() {
        return null;
    }

    /**
     * @deprecated not used by JOnAS Implementation
     * @inheritDoc
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#setWebDDContext(org.apache.geronimo.ews.ws4j2ee.context.j2eeDD.WebContext)
     */
    public void setWebDDContext(WebContext context) {
    }

    /**
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getServiceReferanceContext(int)
     */
    public ServiceReferanceContext getServiceReferanceContext(int index) {
        return (ServiceReferanceContext) srCtx.get(index);
    }

    /**
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#addServiceReferanceContext(org.apache.geronimo.ews.ws4j2ee.context.webservices.client.interfaces.ServiceReferanceContext)
     */
    public void addServiceReferanceContext(ServiceReferanceContext context) {
        srCtx.add(context);
    }

    /**
     * @see org.apache.geronimo.ews.ws4j2ee.context.J2EEWebServiceContext#getServiceReferanceContextCount()
     */
    public int getServiceReferanceContextCount() {
        return srCtx.size();
    }

}
